#pragma once

class CContextHelpMappings
{
public:
	CContextHelpMappings()
	{
		// Initialize the context help mappings. Notice that IDH_OK, IDH_CANCEL, 
		// IDH_HELP are already defined in winuser.h and, thus, a bit different 
		// names are used for these IDs.

		// Mappings for the main dialog. 
        m_MapMainDialog[0].nControlID = IDC_MD_BUTTON1;
		m_MapMainDialog[0].nStringHelpID = IDH_MD_BUTTON1;
		m_MapMainDialog[1].nControlID = IDC_MD_BUTTON_HELP;
		m_MapMainDialog[1].nStringHelpID = IDH_MD_BUTTON_HELP; 
		m_MapMainDialog[2].nControlID = IDOK; 
		m_MapMainDialog[2].nStringHelpID = IDH_MD_BUTTON_OK; 
		m_MapMainDialog[3].nControlID = IDCANCEL; 
		m_MapMainDialog[3].nStringHelpID = IDH_MD_BUTTON_CANCEL; 
		// Mappings for the menu items of the main dialog. Notice that context 
		// menu  strings are not provided for menu roots and menu items that  
		// have subitems since they are not supposed to be provided (see Word  
		// 2000 as sample). These pairs are put at the end of array because 
		// context help for menu items is pretty rarely used.
		m_MapMainDialog[4].nControlID = IDM_TOOLS_OPTIONS;
		m_MapMainDialog[4].nStringHelpID = IDH_TOOLS_OPTIONS;

		// Mappings for the options dialog.
		m_MapOptionsDialog[0].nControlID = IDC_OD_BUTTON_OPTION1;
		m_MapOptionsDialog[0].nStringHelpID = IDH_OD_BUTTON_OPTION1;
		m_MapOptionsDialog[1].nControlID = IDC_OD_BUTTON_OPTION2;
		m_MapOptionsDialog[1].nStringHelpID = IDH_OD_BUTTON_OPTION2; 
	    m_MapOptionsDialog[2].nControlID = IDOK;
		m_MapOptionsDialog[2].nStringHelpID = IDH_OD_BUTTON_OK; 
	    m_MapOptionsDialog[3].nControlID = IDCANCEL;
		m_MapOptionsDialog[3].nStringHelpID = IDH_OD_BUTTON_CANCEL; 
	    m_MapOptionsDialog[4].nControlID = IDC_OD_BUTTON_HELP;
		m_MapOptionsDialog[4].nStringHelpID = IDH_OD_BUTTON_HELP; 
    }
		
	// Set the size of arrays. Notice that "const static" helps initialize 
	// outside the constructor, but inside the class and keeps initialization 
	// in the one place. 
	const static short m_nMapSizeMainDialog = 5;
	const static short m_nMapSizeOptionsDialog = 5;

	struct ContextHelpMap
	{
		DWORD nControlID; 
		DWORD nStringHelpID;
	} m_MapMainDialog[m_nMapSizeMainDialog], 
		                            m_MapOptionsDialog[m_nMapSizeOptionsDialog];
};