// MFC_SHIFT_F1_Help.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MFC_SHIFT_F1_Help.h"
#include "MFC_SHIFT_F1_HelpDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMFC_SHIFT_F1_HelpApp

BEGIN_MESSAGE_MAP(CMFC_SHIFT_F1_HelpApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// CMFC_SHIFT_F1_HelpApp construction

CMFC_SHIFT_F1_HelpApp::CMFC_SHIFT_F1_HelpApp()
{
	// Call by default CHM file instead of HLP file.
	EnableHtmlHelp();
}


// The one and only CMFC_SHIFT_F1_HelpApp object

CMFC_SHIFT_F1_HelpApp theApp;


// CMFC_SHIFT_F1_HelpApp initialization

BOOL CMFC_SHIFT_F1_HelpApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	
	CMFC_SHIFT_F1_HelpDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	return FALSE;
}

// Note: when F1 is presses it should always invoke CHM help except for the case
//       when cursor is inside the rectangle of a control that has focus. In 
//       this case OnF1Help must return FALSE indicating that the event should 
//       behandled by context helpl handler.
BOOL CMFC_SHIFT_F1_HelpApp::OnF1Help(short nDialogID, HELPINFO* pHelpInfo)
{
	CPoint ptControl(pHelpInfo->MousePos.x, pHelpInfo->MousePos.y);
    CRect rcControl;
    CWnd *pWnd = NULL; 
	BOOL bShift;
	TCHAR szHelpTopic[MAX_PATH];

	// Return FALSE if caused by "What's This?" enquiry.
	if (pHelpInfo->hItemHandle == 0) return FALSE; 

	// F1 should be handled differently: the key should invoke CHM help file. 
	// HELPINFO does not help a lot to figure when F1 is pressed (F1, F1+SHIFT, 
	// "?" are all handled with OnHelpInfo). 
	pWnd = CWnd::FromHandle((HWND)pHelpInfo->hItemHandle);
    pWnd->GetWindowRect(rcControl);

	// When mouse outside rectangle call CHM help.
	if (!PtInRect(rcControl, ptControl))
	{
		// MSDN: "If the high-order bit is 1, the key is down; otherwise, it is 
		// up". To check the state I use programmatic idiom meaning that if 
		// GetKeyState(VK_SHIFT) < 0 the SHIFT is button is pressed, and if 
		// "0" is not.
		bShift = (GetKeyState(VK_SHIFT) < 0); 

		if (!bShift)
		{
			// Set initial location of help file to the location of 
			// MFC_SHIFT_F1_Help.chm. The szHelpTopic should be used to point to 
			// specific pages of CHM file e.g. the help pages for dialogs. 
			strcpy(szHelpTopic, m_pszHelpFilePath);
	
			switch (nDialogID)
			{
			case IDD_MFC_SHIFT_F1_HELP_DIALOG : // main dialog
				::HtmlHelp(NULL, szHelpTopic, HH_DISPLAY_TOPIC, 0);
			    break;
			case IDD_OD: // options dialog
				::HtmlHelp(NULL, szHelpTopic, HH_DISPLAY_TOPIC, 0);
			    break;
			default: 
				::HtmlHelp(NULL, szHelpTopic, HH_DISPLAY_TOPIC, 0);
			    break;
			}
			return TRUE; // handled
		}
	}

	return FALSE;
}