// MFC_SHIFT_F1_HelpDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFC_SHIFT_F1_Help.h"
#include "MFC_SHIFT_F1_HelpDlg.h"
#include "Htmlhelp.h" // HH_POPUP

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


CMFC_SHIFT_F1_HelpDlg::CMFC_SHIFT_F1_HelpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFC_SHIFT_F1_HelpDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFC_SHIFT_F1_HelpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMFC_SHIFT_F1_HelpDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_HELPINFO()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(IDM_TOOLS_OPTIONS, OnToolsOptions)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
END_MESSAGE_MAP()

BOOL CMFC_SHIFT_F1_HelpDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set menu. Note that the framework does this automatically when the 
	// application's main window is not a dialog.
	m_Menu.LoadMenu(IDR_MENU);
	SetMenu(&m_Menu);

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMFC_SHIFT_F1_HelpDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFC_SHIFT_F1_HelpDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFC_SHIFT_F1_HelpDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMFC_SHIFT_F1_HelpDlg::OnToolsOptions()
{
	m_dlgOptions.DoModal();
}

void CMFC_SHIFT_F1_HelpDlg::OnHelpAbout()
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

// This enables:
// 1) Click on "?" (and SHIFT+F1) and then click on button shows help popup.
//    Notice that SHIFT+F1 works the same as "?" context help.
// 2) SHIFT+F1 context help for the active menu items.
// 3) F1 shows help popup for control that has focus.
// 4) "What's This?" context help since OnContextMenu redirects messages to the 
// OnHelpInfo.
BOOL CMFC_SHIFT_F1_HelpDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
	HH_POPUP ContextHelpPopup;

    // Check if WM_HELP relates to F1 event.
	if (theApp.OnF1Help(IDD_MFC_SHIFT_F1_HELP_DIALOG , pHelpInfo)) return TRUE;
	
	// Get context menu map's index for the control that was clicked or has 
	// focus (based on iCtrlId value), then get corresponding contex help 
	// string, make up HH_POPUP structure and invoke context help for the 
	// control with HtmlHelp.
	for (int i = 0; i < theApp.m_ContextHelp.m_nMapSizeMainDialog; i++) 
	{
		if (pHelpInfo->iCtrlId ==  
			                 theApp.m_ContextHelp.m_MapMainDialog[i].nControlID) 
	    { 
			// Fill in the popup structure.
			memset(&ContextHelpPopup, 0, sizeof(HH_POPUP) );  
			ContextHelpPopup.cbStruct = sizeof(HH_POPUP);
			ContextHelpPopup.hinst = AfxGetInstanceHandle(); 
			ContextHelpPopup.idString = 
		                  theApp.m_ContextHelp.m_MapMainDialog[i].nStringHelpID; 
			ContextHelpPopup.pt.x = pHelpInfo->MousePos.x;
			ContextHelpPopup.pt.y = pHelpInfo->MousePos.y + 15;
			ContextHelpPopup.pszText = NULL; // recommended (KB241218), 
			                                 // but LL no effect 
			ContextHelpPopup.rcMargins.top    =  5;
			ContextHelpPopup.rcMargins.bottom =  5;
			ContextHelpPopup.rcMargins.left   =  5;
			ContextHelpPopup.rcMargins.right  =  5;
			ContextHelpPopup.clrForeground = -1; // use system color 
			ContextHelpPopup.clrBackground = -1; // use system color 
			//ContextHelpPopup.pszFont = "MS Sans Serif, 10, , BOLD";

			::HtmlHelp(this->m_hWnd, NULL, 
				               HH_DISPLAY_TEXT_POPUP, (DWORD)&ContextHelpPopup);
			::HtmlHelp(this->m_hWnd, NULL, 
				               HH_DISPLAY_TEXT_POPUP, (DWORD)&ContextHelpPopup);
			break;
		}
	}

	return TRUE;
}

// The function realizes "What's This?" context help.  In fact, the context menu 
// is created as usual (manually) and redirection to OnHelpInfo(...) with 
// filled HELPINFO structure is used.
void CMFC_SHIFT_F1_HelpDlg::OnContextMenu(CWnd* pWnd, CPoint point)
{
	CMenu menu;
	CPoint ptT(point);

	ScreenToClient(&point);

	if (pWnd == this) pWnd = ChildWindowFromPoint(point, CWP_SKIPINVISIBLE);
	if (!pWnd || pWnd == this) return;

	menu.CreatePopupMenu();
	menu.AppendMenu(MF_STRING, 0x0100, _T("&What's This?"));

	if (!menu.TrackPopupMenu(TPM_RETURNCMD | TPM_LEFTALIGN | TPM_RIGHTBUTTON,
			                                                ptT.x, ptT.y, this))
	    return; 

	ClientToScreen(&point);
	
	// Re-direct handling to OnHelpInfo.
	HELPINFO hi;
	hi.cbSize = sizeof(HELPINFO);
	hi.dwContextId = 0; // some
	hi.hItemHandle = 0; // some
	hi.iContextType = HELPINFO_WINDOW;
	hi.iCtrlId = pWnd->GetDlgCtrlID(); 
	hi.MousePos = point;
	
	OnHelpInfo(&hi);
}