// OptionsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "MFC_SHIFT_F1_Help.h"
#include "OptionsDialog.h"


// COptionsDialog dialog

IMPLEMENT_DYNAMIC(COptionsDialog, CDialog)
COptionsDialog::COptionsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDialog::IDD, pParent)
{
}

COptionsDialog::~COptionsDialog()
{
}

void COptionsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(COptionsDialog, CDialog)
	ON_WM_HELPINFO()
	ON_WM_CONTEXTMENU()
END_MESSAGE_MAP()


// This enables:
// 1) Click on "?" (and SHIFT+F1) and then click on button shows help popup.
//    Notice that SHIFT+F1 works the same as "?" context help.
// 2) SHIFT+F1 context help for the active menu items.
// 3) F1 shows help popup for control that has focus.
// 4) "What's This?" context help since OnContextMenu redirects messages to the 
// OnHelpInfo.
BOOL COptionsDialog::OnHelpInfo(HELPINFO* pHelpInfo)
{
	HH_POPUP ContextHelpPopup;

	// Check if WM_HELP relates to F1 event.
	if (theApp.OnF1Help(IDD_OD, pHelpInfo)) return TRUE;
	
	// Get context menu map's index for the control that was clicked or has 
	// focus (based on iCtrlId value), then get corresponding contex help 
	// string, make up HH_POPUP structure and invoke context help for the 
	// control with HtmlHelp.
	for (int i = 0; i < theApp.m_ContextHelp.m_nMapSizeOptionsDialog; i++) 
	{
		if (pHelpInfo->iCtrlId ==  
			              theApp.m_ContextHelp.m_MapOptionsDialog[i].nControlID) 
	    { 
			// Fill in the popup structure.
			memset(&ContextHelpPopup, 0, sizeof(HH_POPUP) );  
			ContextHelpPopup.cbStruct = sizeof(HH_POPUP);
			ContextHelpPopup.hinst = AfxGetInstanceHandle(); 
			ContextHelpPopup.idString = 
		              theApp.m_ContextHelp.m_MapOptionsDialog[i].nStringHelpID; 
			ContextHelpPopup.pt.x = pHelpInfo->MousePos.x;
			ContextHelpPopup.pt.y = pHelpInfo->MousePos.y + 15;
			ContextHelpPopup.pszText = NULL; // recommended (KB241218), 
			                                 // but LL no effect 
			ContextHelpPopup.rcMargins.top    =  5;
			ContextHelpPopup.rcMargins.bottom =  5;
			ContextHelpPopup.rcMargins.left   =  5;
			ContextHelpPopup.rcMargins.right  =  5;
			ContextHelpPopup.clrForeground = -1; // use system color 
			ContextHelpPopup.clrBackground = -1; // use system color 
			//ContextHelpPopup.pszFont = "MS Sans Serif, 10, , BOLD";

			::HtmlHelp(this->m_hWnd, NULL, 
				               HH_DISPLAY_TEXT_POPUP, (DWORD)&ContextHelpPopup);
			::HtmlHelp(this->m_hWnd, NULL, 
				               HH_DISPLAY_TEXT_POPUP, (DWORD)&ContextHelpPopup);
			break;
		}
	}

	return TRUE;
}

// The function realizes "What's This?" context help.  In fact, the context menu 
// is created as usual (manually) and redirection to OnHelpInfo(...) with 
// filled HELPINFO structure is used.
void COptionsDialog::OnContextMenu(CWnd* pWnd, CPoint point)
{
	CMenu menu;
	CPoint ptT(point);

	ScreenToClient(&point);

	if (pWnd == this) pWnd = ChildWindowFromPoint(point, CWP_SKIPINVISIBLE);
	if (!pWnd || pWnd == this) return;

	menu.CreatePopupMenu();
	menu.AppendMenu(MF_STRING, 0x0100, _T("&What's This?"));

	if (!menu.TrackPopupMenu(TPM_RETURNCMD | TPM_LEFTALIGN | TPM_RIGHTBUTTON,
			                                                ptT.x, ptT.y, this))
	    return; 

	ClientToScreen(&point);
	
	// Re-direct handling to OnHelpInfo.
	HELPINFO hi;
	hi.cbSize = sizeof(HELPINFO);
	hi.dwContextId = 0; // some
	hi.hItemHandle = 0; // some
	hi.iContextType = HELPINFO_WINDOW;
	hi.iCtrlId = pWnd->GetDlgCtrlID(); 
	hi.MousePos = point;
	
	OnHelpInfo(&hi);
}
